#ifndef _AFTERMATH_PAPI_H_
#define _AFTERMATH_PAPI_H_

#include <stdint.h>
#include <aftermath/trace/trace.h>

struct kmpt_worker_context;
struct kmpt_global_context;

#ifdef KMPT_PAPI_ENABLED
#include <papi.h>

#define KMPT_PAPI_MAX_COUNTER 20
#define PAPI_COUNTER_BASE 1000

#define KMPT_PAPI_WORKER_FIELDS \
	int papi_count; \
	long long* papi_counters; \
	long long* papi_event_mapping; \
	int papi_event_set; \
	int papi_num_counters;

#define KMPT_PAPI_GLOBAL_FIELDS \
	int papi_num_counters; \
	char* papi_counter_names[KMPT_PAPI_MAX_COUNTER];

int kmpt_papi_init(struct kmpt_global_context* gctx);
void kmpt_papi_shutdown(struct kmpt_global_context* gctx);
int kmpt_papi_trace(struct kmpt_worker_context* wctx);
int kmpt_papi_trace_timestamp(struct kmpt_worker_context* wctx,
			      am_timestamp_t timestamp);
int kmpt_papi_worker_init(struct kmpt_worker_context* wctx,
			  struct kmpt_global_context* gctx);
void kmpt_papi_worker_finish(struct kmpt_worker_context* wctx);
#else /* KMPT_PAPI_ENABLED */

#define KMPT_PAPI_WORKER_FIELDS
#define KMPT_PAPI_GLOBAL_FIELDS

static inline int kmpt_papi_init(struct kmpt_global_context* gctx) { return 0; }
static inline void kmpt_papi_shutdown(struct kmpt_global_context* gctx) { }
static inline int kmpt_papi_trace(struct kmpt_worker_context* wctx) { return 0; }

static inline int kmpt_papi_trace_timestamp(struct kmpt_worker_context* wctx,
					am_timestamp_t timestamp)
{ return 0; }

static inline int kmpt_papi_worker_init(struct kmpt_worker_context* wctx,
					struct kmpt_global_context* gctx)
{ return 0; }

static inline void kmpt_papi_worker_finish(struct kmpt_worker_context* wctx) { }

#endif
#endif
